!= Module BasicEnvInit
!
! Authors::   SUGIYAMA Koichiro, ODAKA Masatsugu
! Version::   $Id: initialdata_basic.f90,v 1.7 2011-06-03 06:11:21 sugiyama Exp $
! Tag Name::  $Name:  $
! Copyright:: Copyright (C) GFD Dennou Club, 2006. All rights reserved.
! License::   See COPYRIGHT[link:../../COPYRIGHT]
!
!== Overview 
!
!ǥեȤδܾꤹ뤿ѿȷ⥸塼
!   * BasicEnvFile_init: ܾͤ netCDF ե뤫
!   * BasicEnvCalc_Init: ܾξ Namelist ͤ׻
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
module initialdata_basic
  !
  ! ǥեȤδܾ뤿Υ롼

  !⥸塼ɤ߹
  use dc_types,   only: STRING, DP
  use dc_message, only: MessageNotify
  use gridset,    only: kmin, kmax, &! X ξ¡
    &                 ncmax             !Žʬο
  use axesset, only:  z_Z,          &!顼ʻǤι
    &                 r_dz            !Z γʻֳ
  use constants, only: &
    &                 Grav,          &!ϲ®
    &                 TempSfc, PressSfc, &
    &                 GasRDry        !
  use composition, only: SpcWetMolFr     !Žʬν
  use eccm,     only: ECCM_Dry,      &!
    &                 ECCM_Wet              
    
  !ۤηػ
  implicit none

  !ǥեȤ private
  private

  real(8), save  :: Humidity = 0.0d0        !ܾμ 
!  real(8), save  :: TempSfc   = 300.0d0     !ɽ̲       [K]
!  real(8), save  :: PressSfc  = 965.0d2     !ɽ̰       [Pa]
  real(8), save  :: TempStrat = 100.0d0     !طβ [k]
  real(8), save  :: HeightStrat = 18.0d3    !طι [k]
  real(8), save  :: Dhight = 5.0d3          !ŤߴؿΥѥ᡼ [m]
  integer, save, public :: ID_FlaginitdataBasic = 0
  integer, parameter, public :: ID_FlaginitDataBasic_dry = 1
  integer, parameter, public :: ID_FlaginitDataBasic_moist = 2
  integer, parameter, public :: ID_FlaginitDataBasic_isothermal = 3

  ! public
  public initialdata_basic_nml
  public initialdata_basic_dry
  public initialdata_basic_moist
  public initialdata_basic_strat
  public initialdata_basic_isothermal
    
contains

  subroutine initialdata_basic_nml(cfgfile)
    ! nml ɤ߹
    !
    use dc_iounit,     only : FileOpen    

    implicit none

    character(STRING), intent(in) :: cfgfile    
    integer                       :: unit     !ֹ
    character(STRING)  :: FlaginitdataBasic = ""
    
    NAMELIST /initialdata_basic/ &
      & FlaginitDataBasic, Humidity, TempStrat, HeightStrat, Dhight
    
    call FileOpen(unit, file=cfgfile, mode='r')
    read(unit, NML=initialdata_basic)
    close(unit)

    if (FlaginitdataBasic == "moist") then 
      ID_FlaginitdataBasic = ID_FlaginitdataBasic_moist
    elseif (FlaginitdataBasic == "dry") then
      ID_FlaginitdataBasic = ID_FlaginitdataBasic_dry
    elseif (FlaginitdataBasic == "isothermal") then
      ID_FlaginitdataBasic = ID_FlaginitdataBasic_isothermal
    end if    

  end subroutine initialdata_basic_nml

  subroutine initialdata_basic_isothermal( z_TempBZ, z_PressBZ, za_MolFr )

    implicit none

    real(8), intent(out) :: z_TempBZ(kmin:kmax)
    real(8), intent(out) :: z_PressBZ(kmin:kmax)
    real(8), intent(out) :: za_MolFr(kmin:kmax, 1:ncmax)

    z_TempBZ = TempSfc
    z_PressBZ = PressSfc
    za_MolFr = 0.0d0

  end subroutine initialdata_basic_isothermal

  subroutine initialdata_basic_dry( z_TempBZ, z_PressBZ, za_MolFr )

    implicit none

    real(8), intent(out) :: z_TempBZ(kmin:kmax)
    real(8), intent(out) :: z_PressBZ(kmin:kmax)
    real(8), intent(out) :: za_MolFr(kmin:kmax, 1:ncmax)
    
    call eccm_dry( SpcWetMolFr(1:ncmax), Humidity, z_TempBZ, z_PressBZ, za_MolFr )

  end subroutine initialdata_basic_dry


  subroutine initialdata_basic_moist( z_TempBZ, z_PressBZ, za_MolFr )

    implicit none

    real(8), intent(out) :: z_TempBZ(kmin:kmax)
    real(8), intent(out) :: z_PressBZ(kmin:kmax)
    real(8), intent(out) :: za_MolFr(kmin:kmax, 1:ncmax)
    
    call eccm_wet( SpcWetMolFr(1:ncmax), Humidity, z_TempBZ, z_PressBZ, za_MolFr )
    
  end subroutine initialdata_basic_moist

  
  subroutine initialdata_basic_strat(z_TempBZ, z_PressBZ)
    !
    implicit none
    
    real(8), intent(inout) :: z_TempBZ(kmin:kmax)
    real(8), intent(inout) :: z_PressBZ(kmin:kmax)
    real(8) :: z_DTempDZ(kmin:kmax)
    real(8) :: DTempDZ
    real(8) :: Weight
    integer :: k    
    
    do k = 1, kmax-1
      z_DTempDZ(k) = (z_TempBZ(k) - z_TempBZ(k-1)) / r_dz(k-1)
    end do
    
    ! ή̤ΰ
    !   ̤絤Ȥ. 絤絤ؤܤ 
    !   tanh ѤƤʤ餫ˤĤʤ
    do k = 1, kmax
      
      !ŤߤĤδؿѰ. tanh Ѥ
      Weight = ( tanh( (z_Z(k) - HeightStrat ) / Dhight ) + 1.0d0 ) * 5.0d-1
      
      !ͤȤƲ٤׻. ̤Ǥ TempStrat 絤˶Ť
      z_TempBZ(k) = z_TempBZ(k) * ( 1.0d0 - Weight ) + TempStrat * Weight
      
      !ٸΨǮٸΨ꾮ʤʤ褦
      DTempDZ = &
        & max( z_DTempDZ(k), (z_TempBZ(k) - z_TempBZ(k-1)) / r_dz(k-1) )
      
      !ܾβ٤
      z_TempBZ(k) = z_TempBZ(k-1) + DTempDZ * r_dz(k-1) 
      
      !Ϥſ尵ʿդ׻
      z_PressBZ(k) =                                                    &
        &  z_PressBZ(k-1) * ( ( z_TempBZ(k-1) / z_TempBZ(k) )   &
        &    ** (Grav / ( DTempDZ * GasRDry ) ) )
    end do
    
  end subroutine initialdata_basic_strat
 
end module initialdata_basic
